local mod = ...




-- -- Assets -------------------------------------------------------------------------------------
-- mod:registerAssetId("models/Security4.fbx/Prefab/TEST", "PREFAB_SECURITY_TEST")



-- -- Building -------------------------------------------------------------------------------------
-- mod:register({
-- 	DataType = "BUILDING",
-- 	Id = "BUILDING_SECURITY_TEST",
-- 	Name = "BUILDING_SECURITY_TEST_NAME",
-- 	Description = "BUILDING_SECURITY_TEST_DESC",
--     BuildingType = "SERVICE",
-- 	AssetCoreBuildingPart = "BUILDING_PART_SECURITY_TEST",
--     AssetBuildingFunction = "BUILDING_FUNCTION_WOODEN_KEEP",
-- })



-- -- Building Part -------------------------------------------------------------------------------------
-- mod:register({
--     DataType = "BUILDING_PART",
--     Id = "BUILDING_PART_SECURITY_TEST",
--     Name = "BUILDING_PART_SECURITY_TEST_NAME",
--     ConstructorData = {
--         DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
--         CoreObjectPrefab = "PREFAB_SECURITY_TEST",
--     },
--     AssetBuildingFunction = "BUILDING_FUNCTION_ASSIGNABLE_KEEP",
--     Capacity = 10,
-- })



-- -- Zone -------------------------------------------------------------------------------------
-- mod:register({
--     DataType = "ZONE",
--     Id = "ZONE_SECURITY",
--     Name = "ZONE_SECURITY_NAME",
--     Icon = "ICON_SECURITY",
--     HoverIcon = "ICON_SECURITY",
--     SelectionIcon = "ICON_SECURITY",
--     Color = {2.55, 0.00, 0.00, 0.9}, -- RGB A = red
--     ForbiddenZone = false,
--     ExclusiveZone = false,
--     DesirabilityLayerToShow = "DESIRABILITY_SECURITY",
--     Description = "ZONE_SECURITY_NAME",
--     IsLockedByDefault = false,
--     IsGlobalZone = true,
--     DrawZoneTileCount = {1, 1}
-- })

-- -- Desirability: Security -------------------------------------------------------------------------------------
-- mod:register({
--     DataType = "DESIRABILITY",
--     Id = "DESIRABILITY_SECURITY",
--     Name = "DESIRABILITY_SECURITY",
--     ZoneType = "ZONE_SECURITY",
--     DefaultValue = 0.5,
--     HasBaseDesirabilityBuffer = true,
--     Visible = true,
--     CopyLevelFrom = "DESIRABILITY_FERTILITY",
-- })




-- *************************************************************************************************************
local COMP_TEST = {
	TypeName = "COMP_TEST",
	ParentType = "COMPONENT",
	Properties = {
		-- { Name = "CurrentDay", Type = "integer", Default = 0, Flags = { "SAVE_GAME" } },
		-- { Name = "VillageCenterAdded", Type = "boolean", Default = false, Flags = { "SAVE_GAME" } },
		-- { Name = "SpawnList", Type = "list<string>", Default = nil, Flags = { "SAVE_GAME" } },
    }
}


-- Init -------------------------------------------------------------------------------------
function COMP_TEST:init()

    mod:log("COMP_TEST ______________________________________________________________________________________")
    
    local capacity = nil
    local cost = nil
    local setList = nil

    -- Daily script
    local compMainGameLoop = self:getLevel():find("COMP_MAIN_GAME_LOOP")
    event.register(self, compMainGameLoop.ON_NEW_DAY, function()

        self:getLevel():getComponentManager("COMP_BUILDING"):getAllEnabledComponent():forEach(function(compBuilding)

            mod:log("Building component: " .. tostring(compBuilding:getOwner()))
            compBuilding:getOwner():forEachChild(function(child)
                mod:log("   " .. tostring(child) .. ", " .. tostring(child.Name))
                -- child:forEachChild(function(subChild)
                --     mod:log("      Sub-child: " .. tostring(subChild) .. ", " .. tostring(subChild.Name))
                -- end)
                -- child:forEachComponent(function(comp)
                --     mod:log("Child component: " .. tostring(comp))
                -- end)
            end)

            -- setList = compBuilding.AssetBuilding.BuildingPartSetList
            -- if (setList) then
            --     for i = 1, #setList do
            --         mod:log("Building part set: " .. tostring(setList[i].Name) .. ", " .. tostring(setList[i].BuildingPartList))
            --         if (setList[i].BuildingPartList) then

            --             for p = 1, #setList[i].BuildingPartList do
            --                 -- if (tostring(setList[i].BuildingPartList[p]) == "Asset [\"RusticLordHouseCorePart.data - BUILDING_PART\"]") then
            --                 --     -- setList[i].BuildingPartList[p].Capacity = 50
            --                 -- end
            --                 mod:log("Building part: " .. tostring(setList[i].BuildingPartList[p].Name) .. ", Function = " .. tostring(setList[i].BuildingPartList[p].AssetBuildingFunction) .. ", Capacity = " .. tostring(setList[i].BuildingPartList[p].Capacity) .. ", Cost = " .. tostring(setList[i].BuildingPartList[p].Cost))
            --             end
            --         end
            --     end
            -- end

        end)
    end)
end



-- -- Init -------------------------------------------------------------------------------------
-- function COMP_TEST:init()

--     mod:log("COMP_TEST ______________________________________________________________________________________")
    
--     local capacity = nil
--     local cost = nil
--     local setList = nil

--     -- Daily script
--     local compMainGameLoop = self:getLevel():find("COMP_MAIN_GAME_LOOP")
--     event.register(self, compMainGameLoop.ON_NEW_DAY, function()

--         self:getLevel():getComponentManager("COMP_AGENT"):getAllEnabledComponent():forEach(function(compAgent)

--             mod:log("Agent: " .. tostring(compAgent:getOwner()))

--             compAgent:getOwner():forEachChild(function(child)
--                 mod:log("   Child object: " .. tostring(child) .. ", " .. tostring(child.Name))
--                 child:forEachChild(function(subchild)
--                     mod:log("      Sub-child object: " .. tostring(subchild) .. ", " .. tostring(subchild.Name))
--                 end)
--             end)

--             compAgent:getOwner():forEachComponent(function(comp)
--                 mod:log("   Component: " .. tostring(comp))
--             end)

--         end)
--     end)
-- end


-- Register custom Class
mod:registerClass(COMP_TEST)

-- Attach class to prefab
mod:registerPrefabComponent("PREFAB_MANAGER", { DataType = "COMP_TEST" } )


